import math


def discrete_gaussian(x, mu=0, sd=3.5):

    def dens(x):
        """un-normalised density"""
        math.exp(-(x - mu)**2/(2*sd**2))

    norm = 1/sum([dens(x) for x in range(int(mu-100*sd), int(mu+100*sd))])
    return norm*dens(x)
