from tree_and_grammar.tree_and_grammar_experiments import *

D=14

srange = 10**(np.linspace(-2, 2, 100))
krange = range(4,D+1) #np.linspace(4,D,100)
prange = 10**np.linspace(-4, 0, 100)


####################################33
# MGL

# sf = safe_experiments.SafeFiles('MGLboundary')
# f = csv.writer(sf.open('MGLboundary.csv'), delimiter='\t')
# f2 = csv.writer(sf.open('MGLcontour.csv'), delimiter='\t')

# v = [[ CompleteTreeMGL(D, k, s, create_graph=False).predicted_difference() for s in srange ]
#  for k in krange ]

# found = False
# f.writerow(['k', 's'])
# for (j,r) in enumerate(v):
#     print(krange[j], found)
#     found = False
#     for (i,n) in enumerate(r):
#         if i > 0:
#             if (r[i-1] > 0 and n <= 0) or (r[i-1] < 0 and n >= 0):
#                 f.writerow([krange[j], srange[i]])
#                 found = True
#                 continue
            
# for (j,r) in enumerate(v):
#     f2.writerow([])
#     for (i,n) in enumerate(r):
#         f2.writerow([srange[i], krange[j], n])

# def random_init():
#     """special random init """
#     peak   = random.choice(krange)
#     spread = random.choice(srange)
#     return {
#         'depth'    : D,
#         'peak'     : peak,
#         'spread'   : spread
#     }

# features=[CompleteTreeMGL.goal_peak, 
#                      CompleteTreeMGL.goal_spread, 
#                      CompleteTreeMGL.bfs_wins]

# csvfile = csv.writer(sf.open('mgl.csv'), delimiter='\t')
# csvfile.writerow([f.__name__ for f in features])

# experiment(CompleteTreeMGL, 
#            features=features, 
#            random_init=random_init, 
#            iterate=100,
#            csvfile = csvfile
# )



####################################################
# Binary grammar

krange = range(8,D+1) #np.linspace(4,D,100)
prange = 10**np.linspace(-4, 0, 100)

sf = safe_experiments.SafeFiles('CBboundary')
f = csv.writer(sf.open('CBboundary.csv'), delimiter='\t')
f2 = csv.writer(sf.open('CBcontour.csv'), delimiter='\t')

v = [[ ClusteredGrammar(D, k, p, create_graph=False).predicted_difference() for p in prange ]
 for k in krange ]

for (j,r) in enumerate(v):
    f2.writerow([])
    for (i,n) in enumerate(r):
        f2.writerow([prange[i], krange[j], n])

def random_init():
    """special random init """
    g   = random.choice(krange)
    pg  = random.choice(prange)
    return {
        'depth': D,
        'g'    : g,
        'pg'   : pg
    }

features=[ClusteredGrammar.goal_prob, 
                     ClusteredGrammar.goal_depth, 
                     ClusteredGrammar.bfs_wins]

csvfile = csv.writer(sf.open('mgl.csv'), delimiter='\t')
csvfile.writerow([f.__name__ for f in features])

experiment(ClusteredGrammar, 
           features=features, 
           random_init=random_init, 
           iterate=100,
           csvfile = csvfile
)
