import numpy as np

def delay_exp(rate=1, delay=0):
    return np.random.exponential(1/rate) + delay 

def min_delay(par_list):
    return min( [delay_exp(**par) for par in par_list] )

def delay_exp_expectation(par_list):
    rate   = sum( [ var['rate'] for var in par_list ])
    delay  = sum( [ var['rate']*var['delay'] for var in par_list ] )/rate
    expect = 1/rate + delay
    return expect
    return dict(
        rate   = rate,
        delay  = delay,
        expect = expect
    )
    
def delay_exp_expectation2(par_list):
    rates = [ var['rate']/(1 + var['delay']*var['rate']) for var in par_list ]
    return 1/sum(rates)
    # c1   = sum( [ var['rate'] for var in par_list ])
    # c2  = sum( [ 1/var['delay'] for var in par_list ] )
    # rate = c1 - c2
    # return 1/rate

par1 = [dict(rate=1, delay=0)]
par2 = [dict(rate=1, delay=1)]
par3 = [dict(rate=1, delay=1), dict(rate=3, delay=2)]
par4 = [dict(rate=1, delay=1), dict(rate=3, delay=2), dict(rate=5, delay=0.5)]
par5 = [dict(rate=1, delay=1), dict(rate=1, delay=1), dict(rate=1, delay=1)]
par6 = [dict(rate=1, delay=1), dict(rate=1, delay=1), dict(rate=1, delay=1),dict(rate=1, delay=1), dict(rate=1, delay=1), dict(rate=100, delay=100)]



pars = [par1, par2, par3, par4, par5, par6]

for par in pars:
    c = [ min_delay(par) for i in range(1000) ]
    print(np.average(c), delay_exp_expectation(par), delay_exp_expectation2(par))
    
